<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
  "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.railway.business.baseinfo.mapper.BusJcxcMapper">

  <resultMap id="BaseResultMap" type="com.railway.business.baseinfo.domain.BusJcxc">
    <result column="id" property="id"/>
    <result column="dept_id" property="deptId"/>
    <result column="dept_name" property="deptName"/>
    <result column="line_id" property="lineId"/>
    <result column="line_name" property="lineName"/>
    <result column="station_id" property="stationId"/>
    <result column="station_name" property="stationName"/>
    <result column="dept_station_id" property="deptStationId"/>
    <result column="xingbie" property="xingbie"/>
    <result column="xingbie_text" property="xingbieText"/>
    <result column="xclx_text" property="xclxText"/>
    <result column="pillar_code" property="pillarCode"/>
    <result column="marker" property="marker"/>
    <result column="station_track" property="stationTrack"/>
    <result column="gxms" property="gxms"/>
    <result column="dsgc" property="dsgc"/>
    <result column="remark" property="remark"/>
    <result column="xch" property="xch"/>
    <result column="xclx" property="xclx"/>
    <result column="bzdw" property="bzdw"/>
    <result column="sjbh" property="sjbh"/>
    <result column="del_flag" property="delFlag"/>
    <result column="create_by" property="createBy"/>
    <result column="create_time" property="createTime"/>
    <result column="update_by" property="updateBy"/>
    <result column="update_time" property="updateTime"/>
  </resultMap>

  <sql id="Base_Column_List">
    t.id,
    v.dept_id,
    v.dept_name,
    v.line_id,
    v.line_name,
    v.station_name as station_name,
    v.station_id,
    t.dept_station_id,
    t.xingbie,
    t.pillar_code,
    t.marker,
    t.station_track,
    t.gxms,
    t.dsgc,
    t.remark,
    t.xch,
    t.xclx,
    t.bzdw,
    t.sjbh,
    t.del_flag,
    t.create_by,
    t.create_time,
    t.update_by,
    t.update_time
  </sql>

  <insert id="insert" parameterType="com.railway.business.baseinfo.domain.BusJcxc">
    <selectKey keyProperty="id" order="AFTER" resultType="Long">
      select @@IDENTITY as id
    </selectKey>
    INSERT INTO base_jcxc
    <trim prefix="(" suffix=")" suffixOverrides=",">
      <if test='null != deptStationId'>
        dept_station_id,
      </if>
      <if test='null != xingbie'>
        xingbie,
      </if>
      <if test='null != pillarCode'>
        pillar_code,
      </if>
      <if test='null != stationTrack'>
        station_track,
      </if>
      <if test='null != gxms'>
        gxms,
      </if>
      <if test='null != marker'>
        marker,
      </if>
      <if test='null != dsgc'>
        dsgc,
      </if>
      <if test='null != remark'>
        remark,
      </if>
      <if test='null != xch'>
        xch,
      </if>
      <if test='null != xclx'>
        xclx,
      </if>
      <if test='null != bzdw'>
        bzdw,
      </if>
      <if test='null != delFlag'>
        del_flag,
      </if>
      <if test='null != createBy'>
        create_by,
      </if>
      <if test='null != createTime'>
        create_time,
      </if>
      <if test='null != sjbh'>
        sjbh
      </if>
    </trim>
    <trim prefix="values (" suffix=")" suffixOverrides=",">
      <if test='null != stationId'>
        #{station_id},
      </if>
      <if test='null != xingbie'>
        #{xingbie},
      </if>
      <if test='null != pillarCode'>
        #{pillarCode},
      </if>
      <if test='null != stationTrack'>
        #{stationTrack},
      </if>
      <if test='null != gxms'>
        #{gxms},
      </if>
      <if test='null != marker'>
        #{marker},
      </if>
      <if test='null != dsgc'>
        #{dsgc},
      </if>
      <if test='null != remark'>
        #{remark},
      </if>
      <if test='null != xch'>
        #{xch},
      </if>
      <if test='null != xclx'>
        #{xclx},
      </if>
      <if test='null != bzdw'>
        #{bzdw},
      </if>
      <if test='null != delFlag'>
        #{delFlag},
      </if>
      <if test='null != createBy'>
        #{createBy},
      </if>
      <if test='null != createTime'>
        #{createTime},
      </if>
      <if test='null != sjbh'>
        #{sjbh}
      </if>
    </trim>
  </insert>

  <delete id="delete">
    UPDATE base_jcxc
    set del_flag='1'
    WHERE id = #{id}
  </delete>

  <update id="update" parameterType="com.railway.business.baseinfo.domain.BusJcxc">
    UPDATE base_jcxc
    <set>
      <if test='null != deptStationId'>dept_station_id = #{deptStationId},</if>
      <if test='null != xingbie'>xingbie = #{xingbie},</if>
      <if test='null != pillarCode'>pillar_code = #{pillarCode},</if>
      <if test='null != marker'>marker = #{marker},</if>
      <if test='null != stationTrack'>station_track = #{stationTrack},</if>
      <if test='null != gxms'>gxms = #{gxms},</if>
      <if test='null != dsgc'>dsgc = #{dsgc},</if>
      <if test='null != remark'>remark = #{remark},</if>
      <if test='null != xch'>xch = #{xch},</if>
      <if test='null != xclx'>xclx = #{xclx},</if>
      <if test='null != bzdw'>bzdw = #{bzdw},</if>
      <if test='null != delFlag'>del_flag = #{delFlag},</if>
      <if test='null != updateBy'>update_by = #{updateBy},</if>
      <if test='null != updateTime'>update_time = #{updateTime},</if>
      <if test='null != sjbh'>sjbh = #{sjbh}</if>
    </set>
    WHERE id = #{id}
  </update>


  <select id="getInfo" resultMap="BaseResultMap">
    SELECT
    <include refid="Base_Column_List"/>,
    dict.dict_label as xingbie_text, dict1.dict_label as xclx_text
    FROM base_jcxc t
    LEFT JOIN v_station v on t.dept_station_id = v.dept_station_id
    LEFT JOIN sys_dict_data dict ON (t.xingbie = dict.dict_value AND dict.dict_type = 'xingbie')
    LEFT JOIN sys_dict_data dict1 ON (t.xclx = dict.dict_value AND dict.dict_type = 'forkType')
    WHERE t.del_flag='0' and t.id = #{id}

  </select>

  <select id="getList" resultMap="BaseResultMap">
    SELECT
    <include refid="Base_Column_List"/>,
    dict.dict_label as xingbie_text, dict1.dict_label as xclx_text
    FROM base_jcxc t
    LEFT JOIN v_station v on t.dept_station_id = v.dept_station_id
    LEFT JOIN sys_dict_data dict ON (t.xingbie = dict.dict_value AND dict.dict_type = 'xingbie')
    LEFT JOIN sys_dict_data dict1 ON (t.xclx = dict.dict_value AND dict.dict_type = 'forkType')
    <where>
      t.del_flag='0'
      <if test="deptId!=null and deptId!=''">
        and v.dept_id=#{deptId}
      </if>
      <if test="lineId!=null and lineId!=''">
        and v.line_id=#{lineId}
      </if>
      <if test="stationId!=null and stationId!=''">
        and v.station_id=#{stationId}
      </if>
      <if test="xingbie!=null and xingbie!=''">
        and t.xingbie=#{xingbie}
      </if>
      <if test="pillarCode!=null and pillarCode!=''">
        and t.pillar_code=#{pillarCode}
      </if>
      <if test="marker!=null and marker!=''">
        and t.marker=#{marker}
      </if>
      <if test="xch!=null and xch!=''">
        and t.xch=#{xch}
      </if>
      <if test="xclx!=null and xclx!=''">
        and t.xclx=#{xclx}
      </if>
    </where>
  </select>

</mapper>